#!/usr/bin/python3

import random
import time

import pygame
from pygame.sprite import Sprite
from load import Load

class Sailor_Mercury(Sprite):
    def __init__(self, game):
        """initializes the memory sailor mercury"""
        super().__init__()
        
        #screen set up:
        self.screen = game.screen
        self.screen_rect = self.screen.get_rect()

        #variable flags
        self.stage = 1
        self.money_up = False
        self.work = 0
        self.money_timer = 0
        self.blink_timer = 0
        self.peel = False
        self.water_spin = False
        self.water_spin_meter = 2
        self.end_time = 0


        #loads
        self.read = game.load.read_difference

        #loads sailor mercury images for animations
        self.mercury_idle1 = []
        self.mercury_idle1.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_update1-1.png'))
        self.mercury_idle1.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_update1-2.png'))
        self.mercury_idle1.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_update1-3.png'))
        self.mercury_idle1.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_update1-4.png'))
        self.mercury_idle1.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_update1-5.png'))

        self.mercury_idle1_peeler = []
        self.mercury_idle1_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_peeler1-1.png'))
        self.mercury_idle1_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_peeler1-2.png'))
        self.mercury_idle1_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_peeler1-3.png'))
        self.mercury_idle1_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_peeler1-4.png'))
        self.mercury_idle1_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle1_peeler1-5.png'))
        self.current_idle1 = 0

        self.mercury_idle2 = []
        self.mercury_idle2.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2-1.png'))
        self.mercury_idle2.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2-2.png'))
        self.mercury_idle2.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2-3.png'))
        self.mercury_idle2.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2-4.png'))
        self.mercury_idle2.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2-5.png'))       
        
        self.mercury_idle2_peeler = []
        self.mercury_idle2_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2_peeler1-1.png'))
        self.mercury_idle2_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2_peeler1-2.png'))
        self.mercury_idle2_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2_peeler1-3.png'))
        self.mercury_idle2_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2_peeler1-4.png'))
        self.mercury_idle2_peeler.append(pygame.image.load('sailor_mercury/sailor_mercury_idle2_peeler1-5.png'))
        self.current_idle2 = 0

        self.mercury_idle3 = []
        self.mercury_idle3.append(pygame.image.load('sailor_mercury/sailor_mercury_idle3-1.png'))
        self.mercury_idle3.append(pygame.image.load('sailor_mercury/sailor_mercury_idle3-2.png'))
        self.mercury_idle3.append(pygame.image.load('sailor_mercury/sailor_mercury_idle3-3.png'))
        self.mercury_idle3.append(pygame.image.load('sailor_mercury/sailor_mercury_idle3-4.png'))
        self.mercury_idle3.append(pygame.image.load('sailor_mercury/sailor_mercury_idle3-5.png'))
        self.current_idle3 = 0


        self.mercury_transform1 = []
        self.mercury_transform1.append(pygame.image.load('sailor_mercury/transform1-1.png'))
        self.mercury_transform1.append(pygame.image.load('sailor_mercury/transform1-2.png'))
        self.mercury_transform1.append(pygame.image.load('sailor_mercury/transform1-3.png'))
        self.mercury_transform1.append(pygame.image.load('sailor_mercury/transform1-4.png'))
        self.mercury_transform1.append(pygame.image.load('sailor_mercury/transform1-5.png'))
        self.mercury_transform1.append(pygame.image.load('sailor_mercury/transform1-6.png'))
        self.mercury_transform1.append(pygame.image.load('sailor_mercury/transform1-7.png'))
        self.mercury_transform1.append(pygame.image.load('sailor_mercury/transform1-8.png'))
        
        self.mercury_transform1_peeler = []
        self.mercury_transform1_peeler.append(pygame.image.load('sailor_mercury/transform1_peeler1-1.png'))
        self.mercury_transform1_peeler.append(pygame.image.load('sailor_mercury/transform1_peeler1-2.png'))
        self.mercury_transform1_peeler.append(pygame.image.load('sailor_mercury/transform1_peeler1-3.png'))
        self.mercury_transform1_peeler.append(pygame.image.load('sailor_mercury/transform1_peeler1-4.png'))
        self.mercury_transform1_peeler.append(pygame.image.load('sailor_mercury/transform1_peeler1-5.png'))
        self.mercury_transform1_peeler.append(pygame.image.load('sailor_mercury/transform1_peeler1-6.png'))
        self.mercury_transform1_peeler.append(pygame.image.load('sailor_mercury/transform1_peeler1-7.png'))
        self.mercury_transform1_peeler.append(pygame.image.load('sailor_mercury/transform1_peeler1-8.png'))
        self.current_transform1 = 0

        self.mercury_transform2 = []
        self.mercury_transform2.append(pygame.image.load('sailor_mercury/transform2-1.png'))
        self.mercury_transform2.append(pygame.image.load('sailor_mercury/transform2-2.png'))
        self.mercury_transform2.append(pygame.image.load('sailor_mercury/transform2-3.png'))
        self.mercury_transform2.append(pygame.image.load('sailor_mercury/transform2-4.png'))
        self.mercury_transform2.append(pygame.image.load('sailor_mercury/transform2-5.png'))
        
        self.mercury_transform2_peeler = []
        self.mercury_transform2_peeler.append(pygame.image.load('sailor_mercury/transfrom2_peeler1-1.png'))
        self.mercury_transform2_peeler.append(pygame.image.load('sailor_mercury/transfrom2_peeler1-2.png'))
        self.mercury_transform2_peeler.append(pygame.image.load('sailor_mercury/transfrom2_peeler1-3.png'))
        self.mercury_transform2_peeler.append(pygame.image.load('sailor_mercury/transfrom2_peeler1-4.png'))
        self.mercury_transform2_peeler.append(pygame.image.load('sailor_mercury/transfrom2_peeler1-5.png'))
        self.current_transform2 = 0

        #sets image and rect
        self.image = self.mercury_idle1[self.current_idle1]
        self.rect = self.image.get_rect()

        #places image and rect in correct location
        self.rect.midright = self.screen_rect.midright
        self.rect.y = game.sailor_moon.rect.y

        #money pics
        self.money_image = pygame.image.load('backgrounds/more_money.png')
        self.money_rect = self.money_image.get_rect()
        self.money_rect.midbottom = self.rect.midtop

        #money
        self.money = 0
        self.money_earned = 0

   
    def update(self, game):
        if self.read >= 0 and self.read < 1:
           
            if self.water_spin == True:
                self._spin_water()
            elif self.water_spin == False:
                self._non_spin()
                self.read = game.load.read_difference

            
            #if self.stage == 1:
            #    if self.current_idle1 >= len(self.mercury_idle1):
            #        self.current_idle1 = 0
            #        self.read = game.load.read_difference
            #    
            #    if self.blink_timer >= 15:
            #        self.current_idle1 = 1
            #        self.blink_timer = 0
            #    if self.peel == False:
            #        self.image = self.mercury_idle1[self.current_idle1]
            #    elif self.peel == True:
            #        self.image = self.mercury_idle1_peeler[self.current_idle1]
            # 
            #elif self.stage == 2:
            #    self.stage = 1
            #
            #elif self.stage == 3:
            #    self.stage =2

        elif self.read >= 1 and self.read <= 10:
            if self.stage == 1:
                if self.current_transform1 >= len(self.mercury_transform1):
                    self.current_transform1 = 0
                    self.stage = 2

                if self.stage == 1:
                    if self.peel == False:
                        self.image = self.mercury_transform1[self.current_transform1]
                    elif self.peel == True:
                        self.image = self.mercury_transform1_peeler[self.current_transform1]
                    self.current_transform1 += 1

            elif self.stage == 2:
                if self.current_idle2 >= len(self.mercury_idle2):
                    self.current_idle2 = 0
                    self.read = game.load.read_difference

                if self.peel == False:
                    self.image = self.mercury_idle2[self.current_idle2]
                elif self.peel == True:
                    self.image = self.mercury_idle2_peeler[self.current_idle2]
                self.current_idle2 += 1

            elif self.stage == 3:
                self.stage = 2

        else:
            if self.stage == 1:
                if self.current_transform1 >= len(self.mercury_transform1):
                    self.current_transform1 = 0
                    self.stage = 2

                if self.stage == 1:
                    if self.peel == False:
                        self.image = self.mercury_transform1[self.current_transform1]
                    elif self.peel == True:
                        self.image = self.mercury_transform1_peeler[self.current_transform1]
                    self.current_transform1 += 1

            elif self.stage == 2:
                if self.current_transform2 >= len(self.mercury_transform2):
                    self.current_transform2 = 0
                    self.stage = 3

                if self.stage == 2:
                    if self.peel == False:
                        self.image = self.mercury_transform2[self.current_transform2]
                    elif self.peel == True:
                        self.image = self.mercury_transform2_peeler[self.current_transform2]
                    self.current_transform2 += 1

            elif self.stage == 3:
                if self.current_idle3 >= len(self.mercury_idle3):
                    self.current_idle3 = 0
                    self.read = game.load.read_difference

                self.image = self.mercury_idle3[self.current_idle3]
                self.current_idle3 += 1
        self._peeler(game)
        self._peeler_timer()
        self.work += (game.load.read_difference/(game.settings.difficulty - 150)) * .0025
        if self.work > 1:
            game.money += 1
            self.work -= 1
            self.money_up = True

    def _non_spin(self):
        if self.stage == 1:
            self.blink_timer += 1
            self.current_idle1 = 0
            random_number = random.randrange(50)
            if self.blink_timer >= 15:
                self.current_idle1 = 1
                self.blink_timer = 0
            elif random_number == 10:
                self.water_spin = True
            if self.peel == False:
                self.image = self.mercury_idle1[self.current_idle1]
            elif self.peel == True:
                self.image = self.mercury_idle1_peeler[self.current_idle1]

        elif self.stage == 2:
            self.stage = 1

        elif self.stage == 3:
            self.stage =2

    def _spin_water(self):
        if self.water_spin_meter >= 5:
            self.water_spin_meter = 2
            self.water_spin = False
        else:
            if self.peel == False:
                self.image = self.mercury_idle1[self.water_spin_meter]
            elif self.peel == True:
                self.image = self.mercury_idle1_peeler[self.water_spin_meter]
            self.water_spin_meter += 1


    def money_up_display(self):
        if self.money_timer < 10:
            self.screen.blit(self.money_image, self.money_rect)
            self.money_timer += 1
            self.money_rect.y -= 2
        else:
            self.money_timer = 0
            self.money_rect.midbottom = self.rect.midtop
            self.money_up = False

    def _peeler(self, game):
        if self.peel == False:
            collision = pygame.sprite.spritecollide(game.sailor_mercury, game.moneys, True)
            if collision:
                if self.peel == False:
                    self.money += 1
                else:
                    pass
            if self.money >= game.settings.money_for_nude:
                self.peel = True
                self.money = 0
                self.end_time = time.perf_counter() + game.settings.nude_time

    def _peeler_timer(self):
        if self.peel == False:
            pass
        else:
            updated_time = time.perf_counter()
            if updated_time > self.end_time:
                self.peel = False


class Coming_Soon(Sprite):
    def __init__(self, game):
        super().__init__()

        self.screen_rect = game.screen_rect

        self.coming_soon_idle = []
        self.coming_soon_idle.append(pygame.image.load('sailor_mercury/coming_soon1-1.png'))
        self.coming_soon_idle.append(pygame.image.load('sailor_mercury/coming_soon1-2.png'))
        self.coming_soon_idle.append(pygame.image.load('sailor_mercury/coming_soon1-2.png'))
        self.current_coming_idle = 0

        self.image = self.coming_soon_idle[self.current_coming_idle]
        self.rect = self.image.get_rect()

        self.rect.center = game.sailor_mercury.rect.center

    def update(self, game):
        if self.current_coming_idle >= len(self.coming_soon_idle):
            self.current_coming_idle = 0
        
        self.image = self.coming_soon_idle[self.current_coming_idle]
        self.current_coming_idle += 1


class Venus_Office(Sprite):
    def __init__(self, game):
        """initializes the sailor mercury"""
        super().__init__()
        
        #screen set up:
        self.screen = game.screen
        self.screen_rect = self.screen.get_rect()

        #images

        #creates sailor moon and positions her

    def update(self):
        if self.current_major_cakes >= len(self.major_cakes):
            self.current_major_cakes = 0

        self.image = self.major_cakes[self.current_major_cakes]
        self.current_major_cakes += 1


