#!/usr/bin/python3

import random
import os
import time

import pygame
from pygame.sprite import Sprite
from load import Load
from natsort import natsorted

class Sailor_Venus(Sprite):
    def __init__(self, game):
        """initializes the memory sailor venus"""
        super().__init__()
        
        #screen set up:
        self.screen = game.screen
        self.screen_rect = self.screen.get_rect()

        #variable flags
        self.stage = 1
        self.peel = False
        self.drop = False
        self.drop_ass_meter = 2
        self.grab_ass = False
        self.show_boob = False
        self.money_up = False
        self.spread = False
        self.spread_em = False
        self.spread_em_meter = 4
        self.drop_puss = False
        self.drop_puss_meter = 2
        self.boob_meter = 2
        self.blink_timer = 0
        self.work = 0
        self.money_timer = 0

        #loads
        self.temp = game.load.processor_temp

        #loads idle1 images into list
        self.venus_idle1 = []
        self.venus_idle1.append(pygame.image.load('sailor_venus/sailor_venus4_drop_update1-1.png'))
        self.venus_idle1.append(pygame.image.load('sailor_venus/sailor_venus4_drop_update1-2.png'))
        self.venus_idle1.append(pygame.image.load('sailor_venus/sailor_venus4_drop_update1-3.png'))
        self.venus_idle1.append(pygame.image.load('sailor_venus/sailor_venus4_drop_update1-4.png'))

        self.venus_idle1_peeler = []
        self.venus_idle1_peeler.append(pygame.image.load('sailor_venus/sailor_venus4_drop_update_peeler1-1.png'))
        self.venus_idle1_peeler.append(pygame.image.load('sailor_venus/sailor_venus4_drop_update_peeler1-2.png'))
        self.venus_idle1_peeler.append(pygame.image.load('sailor_venus/sailor_venus4_drop_update_peeler1-3.png'))
        self.venus_idle1_peeler.append(pygame.image.load('sailor_venus/sailor_venus4_drop_update_peeler1-4.png'))
        
        self.current_idle1 = 0

        self.venus_idle2 = []
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-1.png'))
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-2.png'))
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-3.png'))
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-4.png'))
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-5.png'))
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-6.png'))
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-7.png'))
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-8.png'))
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-9.png'))
        self.venus_idle2.append(pygame.image.load('sailor_venus/sailor_venus2-update1-10.png'))
 
        self.venus_idle2_peeler = []
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-1.png'))
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-2.png'))
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-3.png'))
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-4.png'))
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-5.png'))
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-6.png'))
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-7.png'))
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-8.png'))
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-9.png'))
        self.venus_idle2_peeler.append(pygame.image.load('sailor_venus/sailor_venus2-update_peeler1-10.png'))
        
        self.current_idle2 = 0

        self.venus_idle3 = []
        self.venus_idle3.append(pygame.image.load('sailor_venus/sailor_venus_floor1-1.png'))
        self.venus_idle3.append(pygame.image.load('sailor_venus/sailor_venus_floor1-2.png'))
        self.venus_idle3.append(pygame.image.load('sailor_venus/sailor_venus_floor1-3.png'))
        self.venus_idle3.append(pygame.image.load('sailor_venus/sailor_venus_floor1-4.png'))
        self.venus_idle3.append(pygame.image.load('sailor_venus/sailor_venus_floor1-5.png'))
        self.venus_idle3.append(pygame.image.load('sailor_venus/sailor_venus_floor1-6.png'))
        self.venus_idle3.append(pygame.image.load('sailor_venus/sailor_venus_floor1-7.png'))
        self.venus_idle3.append(pygame.image.load('sailor_venus/sailor_venus_floor1-8.png'))
        
        self.venus_idle3_peeler = []
        self.venus_idle3_peeler.append(pygame.image.load('sailor_venus/sailor_venus_floor_peeler1-1.png'))
        self.venus_idle3_peeler.append(pygame.image.load('sailor_venus/sailor_venus_floor_peeler1-2.png'))
        self.venus_idle3_peeler.append(pygame.image.load('sailor_venus/sailor_venus_floor_peeler1-3.png'))
        self.venus_idle3_peeler.append(pygame.image.load('sailor_venus/sailor_venus_floor_peeler1-4.png'))
        self.venus_idle3_peeler.append(pygame.image.load('sailor_venus/sailor_venus_floor_peeler1-5.png'))
        self.venus_idle3_peeler.append(pygame.image.load('sailor_venus/sailor_venus_floor_peeler1-6.png'))
        self.venus_idle3_peeler.append(pygame.image.load('sailor_venus/sailor_venus_floor_peeler1-7.png'))
        self.venus_idle3_peeler.append(pygame.image.load('sailor_venus/sailor_venus_floor_peeler1-8.png'))
        self.current_idle3 = 0

        self.venus_idle4 = []
        self.venus_idle4.append(pygame.image.load('sailor_venus/sailor_venus_idle1-1.png'))
        self.current_idle4 = 0

        #sets image and rect
        self.image = self.venus_idle1[self.current_idle1]
        self.rect = self.image.get_rect()

        #places image and rect in correct location
        self.rect.bottom = self.screen_rect.bottom
        self.rect.x = 0

        #money pics
        self.money_image = pygame.image.load('backgrounds/more_money.png')
        self.money_rect = self.money_image.get_rect()
        self.money_rect.midbottom = self.rect.midtop

        #money
        self.money = 0
        self.money_earned = 0


    def update(self, game):
        if game.load.memory <= 35:
            if self.drop == True:
                self._drop_ass()
            elif self.drop == False:
                self._hold_ass()
 
        elif game.load.memory > 35 and game.load.memory < 70:
            if self.show_boob == True:
                self._show_boob()
            elif self.show_boob == False:
                self._dont_show_boob()

        elif game.load.memory >= 70:
            if self.spread == False:
                self._not_spread()
            elif self.spread == True:
                self._spread()

        self._peeler(game)
        self._peeler_timer()
        self.work += (game.load.memory/(game.settings.difficulty + 50)) * .0025
        if self.work > 1:
            game.money += 1
            self.work -= 1
            self.money_up = True

    def _hold_ass(self):
        self.blink_timer += 1
        self.current_idle1 = 0
        random_number = random.randrange(50)
        if self.blink_timer >= 15:
            self.current_idle1 = 1
            self.blink_timer = 0
        elif random_number == 10:
            self.drop = True
        if self.peel == False:
            self.image = self.venus_idle1[self.current_idle1]
        elif self.peel == True:
            self.image = self.venus_idle1_peeler[self.current_idle1]

    def _drop_ass(self):
        if self.drop_ass_meter >= 4:
            self.drop_ass_meter = 2
            self.drop = False
        else:
            if self.peel == False:
                self.image = self.venus_idle1[self.drop_ass_meter]
            elif self.peel == True:
                self.image = self.venus_idle1_peeler[self.drop_ass_meter]
            self.drop_ass_meter += 1

    def _dont_show_boob(self):
        self.blink_timer += 1
        self.current_idle2 = 0
        random_number = random.randrange(50)
        if self.blink_timer >= 15:
            self.current_idle2 = 1
            self.blink_timer = 0
        elif random_number == 10:
            self.show_boob = True
        if self.peel == False:
            self.image = self.venus_idle2[self.current_idle2]
        elif self.peel == True:
            self.image = self.venus_idle2_peeler[self.current_idle2]

    def _show_boob(self):
        if self.boob_meter >= 10:
            self.boob_meter = 2
            self.show_boob = False
        else:
            if self.peel == False:
                self.image = self.venus_idle2[self.boob_meter]
            elif self.peel == True:
                self.image = self.venus_idle2_peeler[self.boob_meter]
            self.boob_meter += 1

    def _spread(self):
        if self.drop_puss == True:
            self._drop_puss()
        else:
            self.blink_timer += 1
            self.current_idle3 = 0
            random_number = random.randrange(50)
            if self.blink_timer >= 15:
                self.current_idle3 = 1
                self.blink_timer = 0
            elif random_number == 10:
                self.drop_puss = True
            if self.peel == False:
                self.image = self.venus_idle3[self.current_idle3]
            elif self.peel == True:
                self.image = self.venus_idle3_peeler[self.current_idle3]

    def _drop_puss(self):
        if self.drop_puss_meter >= 4:
            self.drop_puss_meter = 2
            self.drop_puss = False
            self.spread = False
        else:
            if self.peel == False:
                self.image = self.venus_idle3[self.drop_puss_meter]
            elif self.peel == True:
                self.image = self.venus_idle3_peeler[self.drop_puss_meter]
            self.drop_puss_meter += 1

    def _not_spread(self):
        if self.spread_em == True:
            self._spread_em()
        else:
            self.blink_timer += 1
            self.current_idle3 = 3
            random_number = random.randrange(50)
            if self.blink_timer >= 15:
                self.current_idle3 = 4
                self.blink_timer = 0
            elif random_number == 10:
                self.spread_em = True
            if self.peel == False:
                self.image = self.venus_idle3[self.current_idle3]
            elif self.peel == True:
                self.image = self.venus_idle3_peeler[self.current_idle3]

    def _spread_em(self):
        if self.spread_em_meter >= 8:
            self.spread_em_meter = 4
            self.spread_em = False
            self.spread = True
        else:
            if self.peel == False:
                self.image = self.venus_idle3[self.spread_em_meter]
            elif self.peel == True:
                self.image = self.venus_idle3_peeler[self.spread_em_meter]
            self.spread_em_meter += 1

    def money_up_display(self):
        if self.money_timer < 10:
            self.screen.blit(self.money_image, self.money_rect)
            self.money_timer += 1
            self.money_rect.y -= 2
        else:
            self.money_timer = 0
            self.money_rect.midbottom = self.rect.midtop
            self.money_up = False
    
    def _peeler(self, game):
        if self.peel == False:
            collision = pygame.sprite.spritecollide(game.sailor_venus, game.moneys, True)
            if collision:
                if self.peel == False:
                    self.money += 1
                else:
                    pass
            if self.money >= game.settings.money_for_nude:
                self.peel = True
                self.money = 0
                self.end_time = time.perf_counter() + game.settings.nude_time

    def _peeler_timer(self):
        if self.peel == False:
            pass
        else:
            updated_time = time.perf_counter()
            if updated_time > self.end_time:
                self.peel = False


class Venus_Ahegao(Sprite):
    def __init__(self, game):
        """initializes the ahegao face"""
        super().__init__()
        
        self.screen = game.screen
        self.screen_rect = game.screen_rect

        #loads the ahegao images and makes rect
        self.image = pygame.image.load('sailor_venus/ahegao1-1.png')
        self.ahegao_1 = pygame.image.load('sailor_venus/ahegao1-1.png')
        self.ahegao_2 = pygame.image.load('sailor_venus/ahegao1-2.png')
        self.ahegao_3 = pygame.image.load('sailor_venus/ahegao1-3.png')
        self.ahegao_4 = pygame.image.load('sailor_venus/ahegao1-4.png')
        self.ahegao_5 = pygame.image.load('sailor_venus/ahegao1-5.png')
        self.rect = self.ahegao_1.get_rect()

        #position rect
        self.rect.midbottom = game.sailor_venus.rect.midtop
        self.rect.y = self.screen_rect.y

    def update(self, game):
        if game.load.memory > 80:
            self.image = self.ahegao_5
        elif game.load.memory > 60:
            self.image = self.ahegao_4
        elif game.load.memory > 40:
            self.image = self.ahegao_3
        elif game.load.memory > 20:
            self.image = self.ahegao_2
        else:
            self.image = self.ahegao_1

class Venus_Cakes(Sprite):
    def __init__(self, game):
        """initializes the sailor moon walking"""
        super().__init__()
        
        #screen set up:
        self.screen = game.screen
        self.screen_rect = self.screen.get_rect()

        #images
        self.major_cakes = []
        self.major_cakes.append(pygame.image.load('sailor_venus/major_cakes1-1.png'))
        self.major_cakes.append(pygame.image.load('sailor_venus/major_cakes1-2.png'))
        self.major_cakes.append(pygame.image.load('sailor_venus/major_cakes1-3.png'))
        self.major_cakes.append(pygame.image.load('sailor_venus/major_cakes1-4.png'))

        self.current_major_cakes = 0

        #creates sailor moon and positions her
        self.image = self.major_cakes[self.current_major_cakes]
        self.rect = self.image.get_rect()
        self.rect.bottomright = self.screen_rect.bottomright

    def update(self):
        if self.current_major_cakes >= len(self.major_cakes):
            self.current_major_cakes = 0

        self.image = self.major_cakes[self.current_major_cakes]
        self.current_major_cakes += 1

class Venus_Gauge(Sprite):
    def __init__(self, game):
        """initilizes the Gauge"""
        super().__init__()

        #screen set up:
        self.screen = game.screen
        self.screen_rect = self.screen.get_rect()

        self.gauge_names = []
        self.gauge_images = []
        all_gauge_names = os.listdir('sailor_moon/gauge/')
        for files in all_gauge_names:
            if 'up' not in files:       
                self.gauge_names.append(files)
        self.gauge_names = natsorted(self.gauge_names)
        for files in self.gauge_names:
                self.gauge_images.append(pygame.image.load(f'sailor_moon/gauge/{files}'))           

        #images
        self.image = pygame.image.load('sailor_moon/gauge/gauge0.png')
        self.rect = self.image.get_rect()
        self.rect.topleft = self.screen_rect.topleft
    
    def update(self, game):
        self.load = game.load
        self.memory = int(self.load.memory)
        self.image = self.gauge_images[self.memory]

class Coming_Soon(Sprite):
    def __init__(self, game):
        super().__init__()

        self.screen_rect = game.screen_rect

        self.coming_soon_idle = []
        self.coming_soon_idle.append(pygame.image.load('sailor_venus/coming_soon1-1.png'))
        self.coming_soon_idle.append(pygame.image.load('sailor_venus/coming_soon1-2.png'))
        self.coming_soon_idle.append(pygame.image.load('sailor_venus/coming_soon1-2.png'))
        self.current_coming_idle = 0

        self.image = self.coming_soon_idle[self.current_coming_idle]
        self.rect = self.image.get_rect()

        self.rect.center = game.sailor_venus.rect.center

    def update(self, game):
        if self.current_coming_idle >= len(self.coming_soon_idle):
            self.current_coming_idle = 0
        
        self.image = self.coming_soon_idle[self.current_coming_idle]
        self.current_coming_idle += 1
